# - Try to find ATI Stream
# Once done this will define
#  ATI_TOOLKIT_FOUND
#  ATI_TOOLKIT_ROOT_DIR
#  ATI_TOOLKIT_INCLUDE_DIRS
#  ATI_TOOLKIT_LIBRARIES


if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(ATI_ARCHLIB "x86_64")
  set(ATI_ARCHEXT "64")
else(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(ATI_ARCHLIB "x86")
  set(ATI_ARCHEXT "32")
endif(CMAKE_SIZEOF_VOID_P EQUAL 8)


FILE(GLOB ATI_TOOLKIT_SEARCH_PATH 
    "/opt/ati"
    "/opt/ati-stream"
    "/opt/ati-stream-sdk"
    "/opt/stream"
    "/opt/stream-sdk"
    "/opt/amd-app-sdk"
    "/opt/AMD-APP-SDK"
    "/opt/AMDAPP"
    "/usr/local/ati"
    "/usr/local/ati-stream"
    "/usr/local/ati-stream-sdk"
    "/usr/local/stream"
    "/usr/local/stream-sdk"
    "/usr/local/amd-app-sdk"
    "/usr/local/AMD-APP-SDK"
    "/usr/local/AMDAPP"
)

if (NOT ATI_TOOLKIT_SEARCH_PATH)
  FILE(GLOB ATI_TOOLKIT_SEARCH_PATH 
    "/opt/ati*"
    "/opt/stream*"
    "/opt/amd-app-sdk*"
    "/opt/AMD-APP-SDK*"
    "/opt/AMDAPP*"
    "/usr/local/ati*"
    "/usr/local/stream*"
    "/usr/local/amd-app-sdk*"
    "/usr/local/AMD-APP-SDK*"
    "/usr/local/AMDAPP*"
  )
endif()


FIND_PATH(ATI_TOOLKIT_ROOT_DIR 
  NAME
    lib/libaticalcl.so
  PATHS
    ${ATI_TOOLKIT_SEARCH_PATH}
  NO_DEFAULT_PATH
)

if (NOT ATI_TOOLKIT_ROOT_DIR)
    FIND_PATH(ATI_TOOLKIT_ROOT_DIR 
      NAMES 
	lib/${ATI_ARCHLIB}/libatiocl${ATI_ARCHEXT}.so
	lib/${ATI_ARCHLIB}/libamdocl${ATI_ARCHEXT}.so
     PATHS
	${ATI_TOOLKIT_SEARCH_PATH}
     NO_DEFAULT_PATH
    )
endif()

if (NOT ATI_TOOLKIT_ROOT_DIR)
    FIND_PATH(ATI_TOOLKIT_ROOT_DIR 
      NAMES 
	lib/${ATI_ARCHLIB}/libatiocl${ATI_ARCHEXT}.so
	lib/${ATI_ARCHLIB}/libamdocl${ATI_ARCHEXT}.so
     PATHS
	${ATI_TOOLKIT_SEARCH_PATH}
	ENV LD_LIBRARY_PATH
    )
endif()


FIND_PATH(ATI_TOOLKIT_INCLUDE_DIRS
  NAMES
    CL/cl.h 
  PATH_SUFFIXES
    include
  PATHS
    ${ATI_TOOLKIT_ROOT_DIR}
    ${ATI_TOOLKIT_SEARCH_PATH}
)

FIND_LIBRARY(ATI_TOOLKIT_LIBRARIES
  NAMES
    atiocl${ATI_ARCHEXT} 
    amdocl${ATI_ARCHEXT} 
  PATHS
    ENV LD_LIBRARY_PATH
    ${ATI_TOOLKIT_ROOT_DIR}
  PATH_SUFFIXES 
    "lib/${ATI_ARCHLIB}"
)

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(ATI_TOOLKIT DEFAULT_MSG ATI_TOOLKIT_INCLUDE_DIRS ATI_TOOLKIT_LIBRARIES)
    
mark_as_advanced(ATI_TOOLKIT_INCLUDE_DIRS ATI_TOOLKIT_LIBRARIES)
